package soccerTeamExample_tableVersion;

import javax.swing.table.AbstractTableModel;

/*
 * Copyright (c) 1995, 2008, Oracle and/or its affiliates. All rights reserved.
 *
 */
class SoccerPlayerTableModel extends AbstractTableModel {

	private static final boolean DEBUG = true;
	private String[] columnNames = { "Player Attribute", "Attribute Value" };
	private String[] firstColumnValues = { "First Name", "Last Name",
			"Address", "Phone Number" };

	private String DEFAULT_VAL = "<unknown>";

	private Object[][] data = { { firstColumnValues[0], DEFAULT_VAL },
			{ firstColumnValues[1], DEFAULT_VAL },
			{ firstColumnValues[2], DEFAULT_VAL },
			{ firstColumnValues[3], DEFAULT_VAL } };

	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return data.length;
	}

	public String getColumnName(int col) {
		return columnNames[col];
	}

	public Object getValueAt(int row, int col) {
		return data[row][col];
	}

	/*
	 * JTable uses this method to determine the default renderer/ editor for
	 * each cell. If we didn't implement this method, then the last column would
	 * contain text ("true"/"false"), rather than a check box.
	 */
	public Class<?> getColumnClass(int c) {
		return getValueAt(0, c).getClass();
	}

	/*
	 * Don't need to implement this method unless your table's editable.
	 */
	public boolean isCellEditable(int row, int col) {
		// Note that the data/cell address is constant,
		// no matter where the cell appears onscreen.
		if (col < 1) {
			return false;
		} else {
			return true;
		}
	}

	/*
	 * Don't need to implement this method unless your table's data can change.
	 */
	public void setValueAt(Object value, int row, int col) {
		if (DEBUG) {
			System.out.println("Setting value at " + row + "," + col + " to "
					+ value + " (an instance of " + value.getClass() + ")");
		}

		data[row][col] = value;
		fireTableCellUpdated(row, col);

		if (DEBUG) {
			System.out.println("New value of data:");
			printDebugData();
		}
	}

	private void printDebugData() {
		int numRows = getRowCount();
		int numCols = getColumnCount();

		for (int i = 0; i < numRows; i++) {
			System.out.print("    row " + i + ":");
			for (int j = 0; j < numCols; j++) {
				System.out.print("  " + data[i][j]);
			}
			System.out.println();
		}
		System.out.println("--------------------------");
	}
	
	public String getFirstName() {
		return data[0][1].toString();
	}
	
	public String getLastName() {
		return data[1][1].toString();
	}
	
	public String getAddress() {
		return data[2][1].toString();
	}

	public String getPhoneNumber() {
		return data[3][1].toString();
	}

}
